package ww2spring.action;

import ww2spring.entity.User;
import ww2spring.service.AuthenticationService;
import ww2spring.service.SessionService;

/**
 * OCANV
 */
public class LoginAction extends BaseAction {

	// ----------------------------------------------------------------
	// T[rX
	// ----------------------------------------------------------------
	private AuthenticationService authenticationService;
	public void setAuthenticationService(AuthenticationService authenticationService) {
		this.authenticationService = authenticationService;
	}

	private SessionService sessionService;
	public void setSessionService(SessionService sessionService) {
		this.sessionService = sessionService;
	}

	// ----------------------------------------------------------------
	// ANV
	// ----------------------------------------------------------------

	public String display() throws Exception {
		return INPUT;
	}
	
	public String execute() throws Exception
	{
		// F؏
		User user = authenticationService.authenticate(getUserId(), getPassword());

		if(user == null) {
			// OCs
			addActionError(getText("error.login.invalid"));
			return INPUT;
		} else {
			// OCAZbVɃ[Ui[
			sessionService.setUser(user, getSession());
			return SUCCESS;
		}
	}

	// ----------------------------------------------------------------
	// tB[h
	// ----------------------------------------------------------------

	private String userId;
	private String password;

	/**
	 * @return
	 */
	public String getUserId() {
		return userId;
	}

	/**
	 * @return
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * @param string
	 */
	public void setUserId(String string) {
		userId = string;
	}

	/**
	 * @param string
	 */
	public void setPassword(String string) {
		password = string;
	}

}
