package ww2spring.dao.jdbc;

import java.sql.SQLException;
import java.util.List;

import org.apache.commons.dbutils.QueryRunner;
import org.apache.commons.dbutils.handlers.BeanHandler;
import org.apache.commons.dbutils.handlers.BeanListHandler;

import ww2spring.dao.BookCategoryDao;
import ww2spring.entity.BookCategory;

/**
 * ЃJeSDAONX
 */
public class JdbcBookCategoryDao extends BaseJdbcDao implements BookCategoryDao {
	
	public List getBookCategories() {
		try {
			QueryRunner runner = new QueryRunner(getDataSource());
			List result = (List)runner.query(
					"select * from book_categories order by code", 
					new BeanListHandler(BookCategory.class, 
					JoinedRowProcessor.instance()));
			return result;
		} catch (SQLException e) {
			throw new DataAccessException("JdbcBookCategoryDao: unable to execute query", e);
		}
	}

	public BookCategory loadBookCateogory(String code) {
		try {
			QueryRunner runner = new QueryRunner(getDataSource());
			BookCategory result = (BookCategory)runner.query(
					"select * from book_categories where code=?", 
					new Object[] {code},
					new BeanHandler(BookCategory.class, JoinedRowProcessor.instance()));
			return result;
		} catch (SQLException e) {
			throw new DataAccessException("JdbcBookCategoryDao: unable to execute query", e);
		}
	}
}