package ww2spring.dao.mock;

import java.util.ArrayList;
import java.util.List;

import ww2spring.dao.BookDao;
import ww2spring.entity.Book;

/**
 * DAONX
 */
public class MockBookDao implements BookDao {

	public Book loadBook(String code) {
		Book book = new Book();
		book.setCode(code);
		book.setName("product(" + code + ")");
		book.setCategoryCode("dummy");
		book.setPrice(1000);
		return book;
	}

	/* ( Javadoc)
	 * @see picoruts.dao.BookDao#getBooks()
	 */
	public List getBooks() {
		ArrayList books = new ArrayList();
		books.addAll(getBooksByCategoryCode("1"));
		books.addAll(getBooksByCategoryCode("2"));
		books.addAll(getBooksByCategoryCode("3"));
		books.addAll(getBooksByCategoryCode("4"));
		return books;
	}


	public List getBooksByCategoryCode(String categoryCode) {
		ArrayList books = new ArrayList();
		for (int i = 0; i < 10; i++) {
			Book book = new Book();
			book.setCode("code" + i);
			book.setName("product" + i);
			book.setCategoryCode(categoryCode);
			book.setPrice(i * 1000);
			books.add(book);
		}
		return books;
	}

	public void updateBook(Book book) {
	}

}