package ww2spring.interceptor;

import javax.servlet.ServletContext;

import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import ww2spring.service.SessionService;

import com.opensymphony.webwork.ServletActionContext;
import com.opensymphony.xwork.Action;
import com.opensymphony.xwork.ActionInvocation;
import com.opensymphony.xwork.interceptor.Interceptor;


/**
 * OC`FbN
 */
public class SecureInterceptor implements Interceptor {
	public String intercept(ActionInvocation invocation) throws Exception {
		ServletContext servletContext = ServletActionContext.getServletConfig().getServletContext();
		ApplicationContext applicationContext = WebApplicationContextUtils.getWebApplicationContext(servletContext);
		SessionService sessionService = (SessionService) applicationContext.getBean("sessionService");

		if(!sessionService.isLogin(ServletActionContext.getContext().getSession())) {
			// OC
			return Action.LOGIN;
		}
		// OCς
		return invocation.invoke();
	}

	public void destroy() {}

	public void init() {}
}
