/*
 * Copyright (c) 2002-2003 by OpenSymphony
 * All rights reserved.
 */
/*
 * Created on Nov 11, 2003
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package ww2spring.interceptor;

import javax.servlet.ServletContext;

import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import com.atlassian.xwork.ext.SpringApplicationContextAware;
import com.opensymphony.webwork.ServletActionContext;
import com.opensymphony.xwork.Action;
import com.opensymphony.xwork.ActionInvocation;
import com.opensymphony.xwork.interceptor.AroundInterceptor;


/**
 * @author Ross
 *
 * Resolves external references using the <code>ExternalReferenceResolver</code> configured on the package
 * Reference Resolution is encapsulated in an interceptor so that the user can configure when references should
 * be resloved
 */
public class SpringApplicationContextAwareInterceptor extends AroundInterceptor {
    //~ Methods ////////////////////////////////////////////////////////////////

    protected void after(ActionInvocation dispatcher, String result) throws Exception {
    }

    protected void before(ActionInvocation invocation) throws Exception {
    	Action action = invocation.getAction();
    	if(action instanceof SpringApplicationContextAware) {
    		ServletContext servletContext = ServletActionContext.getServletConfig().getServletContext();
    		ApplicationContext applicationContext = WebApplicationContextUtils.getWebApplicationContext(servletContext);
    		((SpringApplicationContextAware) action).setApplicationContext(applicationContext);
    	}
    }
}
