package ww2spring.service.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Map;

import org.apache.commons.beanutils.BeanUtils;

import ww2spring.entity.User;
import ww2spring.service.SessionService;

/**
 * ZbVT[rX̎NX
 */
public class SessionServiceImpl implements SessionService {
	
	public static final String ATTR_USER = "_user";
	
	public User getUser(Map session) {
		User user = (User) session.get(ATTR_USER);
		return user;
	}
	
	public void setUser(User user, Map session) {
		session.put(ATTR_USER, user);
	}

	public void removeUser(Map session) {
		session.remove(ATTR_USER);
	}

	
	public boolean isLogin(
		Map session) {
		return (getUser(session) != null);
	}

	public void storeCondition(Map session, Object condition) {
		session.put(condition.getClass().getName(), condition);
	}

	public void restoreCondition(Map session, Object condition) {
		Object storedCondition = 
			session.get(condition.getClass().getName());
		if(storedCondition != null) {
			try {
				BeanUtils.copyProperties(condition, storedCondition);
			} catch (IllegalAccessException e) {
				throw new RuntimeException("DefaultSessionService: unable to BeanUtils.copyProperties", e);
			} catch (InvocationTargetException e) {
				throw new RuntimeException("DefaultSessionService: unable to BeanUtils.copyProperties", e);
			}
		}
	}

	public void removeCondition(Map session, Object condition) {
		session.remove(condition.getClass().getName());
	}

}